#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
 Version : 1.0 (27-04-2017) (updated: 07-06-2022)
 
 Author  : Giovanni Chierchia

 Copyright (C) 2017
 
 DEPENDENCIES:
     'Thresholhder.py' in the folder 'scalar'
     
 This file is part of the codes provided at http://proximity-operator.net
 
 By downloading and/or using any of these files, you implicitly agree to 
 all the terms of the license CeCill-B (available online).
 """
   

from package_prox.scalar.Thresholder import Thresholder

class AbsValue(Thresholder):
    """
    This class computes the proximity operator of the function

                       f(x) = gamma *tau * |x|

    'gamma * tau' is the scale factor
    
    When the input 'x' is an array, the output is computed element-wise.

     INPUTS
    ========
    x     - ND array
    gamma - positive, scalar or ND array with the same size as 'x' [default: gamma=1]
    tau   - positive, scalar or ND array with the same size as 'x' [default: tau=1]    """
    
    def __init__(self, gamma=1):

        super().__init__( -1, 1, gamma)